Loading...
Searching...
No Matches
casacore::VACEngine< T > Class Template Reference
tables package (libcasa_tables) » DataMan_module

More...

`#include <VACEngine.h>`

## Public Member Functions

| VACEngine ()=default
| The default constructor is required for reconstruction of the engine when a table is read back.
| VACEngine (const String &sourceColumnName)
| Construct an engine to handle a column with an arbitrary data type.
virtual | ~VACEngine ()=default
| Destructor.
VACEngine< T > & | operator= (const VACEngine< T > &)=delete
| Assignment is not needed and therefore forbidden.
String | dataManagerType () const
| Return the data manager type name.
const String & | sourceColumnName () const
| Get the name of the source column.
Public Member Functions inherited from casacore::VirtualColumnEngine
| VirtualColumnEngine ()
| Create the object.
virtual | ~VirtualColumnEngine ()
| VirtualColumnEngine (const VirtualColumnEngine &)=delete
| The copy constructor cannot be used for this base class.
VirtualColumnEngine & | operator= (const VirtualColumnEngine &)=delete
| Assignment cannot be used for this base class.
Public Member Functions inherited from casacore::DataManager
| DataManager ()
| Default constructor.
virtual | ~DataManager ()
| DataManager (const DataManager &)=delete
| The copy constructor cannot be used for this base class.
DataManager & | operator= (const DataManager &)=delete
| Assignment cannot be used for this base class.
virtual DataManager * | clone () const =0
| Make a clone of the derived object.
virtual String | dataManagerName () const
| Return the name of the data manager.
void | dataManagerInfo (Record &info) const
| Add SEQNR and SPEC (the DataManagerSpec subrecord) to the info.
virtual Record | dataManagerSpec () const
| Return a record containing data manager specifications.
virtual Record | getProperties () const
| Get data manager properties that can be modified.
virtual void | setProperties (const Record &spec)
| Modify data manager properties given in record fields.
virtual Bool | canReallocateColumns () const
| Tell if the data manager wants to reallocate the data manager column objects.
virtual DataManagerColumn * | reallocateColumn (DataManagerColumn *column)
| Reallocate the column object if it is part of this data manager.
uInt | sequenceNr () const
| Get the (unique) sequence nr of this data manager.
uInt | ncolumn () const
| Get the nr of columns in this data manager (can be zero).
Bool | asBigEndian () const
| Have the data to be stored in big or little endian canonical format?
const TSMOption & | tsmOption () const
| Get the TSM option.
std::shared_ptr< MultiFileBase > | multiFile ()
| Get the MultiFile pointer (can be 0).
String | keywordName (const String &keyword) const
| Compose a keyword name from the given keyword appended with the sequence number (e.g.
String | fileName () const
| Compose a unique filename from the table name and sequence number.
ByteIO::OpenOption | fileOption () const
| Get the AipsIO option of the underlying file.
virtual Bool | isRegular () const
| Is this a regular storage manager?
Table & | table () const
| Get the table this object is associated with.
virtual void | reopenRW ()
| Reopen the data manager for read/write access.
virtual Bool | canAddColumn () const
| Does the data manager allow to add columns?
virtual Bool | canRemoveColumn () const
| Does the data manager allow to delete columns?
virtual Bool | canRenameColumn () const
| Does the data manager allow to rename columns?
virtual void | setMaximumCacheSize (uInt nMiB)
| Set the maximum cache size (in bytes) to be used by a storage manager.
virtual void | showCacheStatistics (std::ostream &) const
| Show the data manager's IO statistics.
DataManagerColumn * | createScalarColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a column in the data manager on behalf of a table column.
DataManagerColumn * | createDirArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a direct array column.
DataManagerColumn * | createIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create an indirect array column.
DataManager * | getClone () const
| Has the object already been cloned?
void | setClone (DataManager *clone) const
| Set the pointer to the clone.
Public Member Functions inherited from casacore::VirtualArrayColumn< T >
| VirtualArrayColumn ()
| Create a column.
virtual | ~VirtualArrayColumn ()
| VirtualArrayColumn (const VirtualArrayColumn< T > &)=delete
| The object cannot be copied.
VirtualArrayColumn< T > & | operator= (const VirtualArrayColumn< T > &)=delete
| The object cannot be assigned to.
virtual int | dataType () const
| Return the data type of the column.
virtual String | dataTypeId () const
| Return the data type Id of the column.
Public Member Functions inherited from casacore::VirtualArrayColumnBase
| VirtualArrayColumnBase ()
| Create a column.
virtual | ~VirtualArrayColumnBase ()
Public Member Functions inherited from casacore::DataManagerColumn
| DataManagerColumn ()
| Create a column.
virtual | ~DataManagerColumn ()
| Frees up the storage.
| DataManagerColumn (const DataManagerColumn &)=delete
| The copy constructor cannot be used for this base class.
DataManagerColumn & | operator= (const DataManagerColumn &)=delete
| Assignment cannot be used for this base class.
void | setIsFixedShape (Bool isFixedShape)
| Set the isFixedShape flag.
Bool | isFixedShape () const
| Is this a fixed shape column?
virtual void | setMaxLength (uInt maxLength)
| Set the maximum length of the value (can be used for strings).
void | setFixedShapeColumn (const IPosition &shape)
| Set the shape of all (fixed-shaped) arrays in the column.
virtual void | setShapeTiled (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of an (variable-shaped) array in the given row.
virtual uInt | ndim (rownr_t rownr)
| Get the dimensionality of the item in the given row.
virtual IPosition | tileShape (rownr_t rownr)
| Get the tile shape of the item in the given row.
virtual Bool | canChangeShape () const
| Can the data manager handle chaging the shape of an existing array?
ColumnCache & | columnCache ()
| Get access to the ColumnCache object.
const ColumnCache * | columnCachePtr () const
void | get (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
void | get (rownr_t rownr, uChar *dataPtr)
void | get (rownr_t rownr, Short *dataPtr)
void | get (rownr_t rownr, uShort *dataPtr)
void | get (rownr_t rownr, Int *dataPtr)
void | get (rownr_t rownr, uInt *dataPtr)
void | get (rownr_t rownr, Int64 *dataPtr)
void | get (rownr_t rownr, float *dataPtr)
void | get (rownr_t rownr, double *dataPtr)
void | get (rownr_t rownr, Complex *dataPtr)
void | get (rownr_t rownr, DComplex *dataPtr)
void | get (rownr_t rownr, String *dataPtr)
void | get (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
void | put (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
void | put (rownr_t rownr, const uChar *dataPtr)
void | put (rownr_t rownr, const Short *dataPtr)
void | put (rownr_t rownr, const uShort *dataPtr)
void | put (rownr_t rownr, const Int *dataPtr)
void | put (rownr_t rownr, const uInt *dataPtr)
void | put (rownr_t rownr, const Int64 *dataPtr)
void | put (rownr_t rownr, const float *dataPtr)
void | put (rownr_t rownr, const double *dataPtr)
void | put (rownr_t rownr, const Complex *dataPtr)
void | put (rownr_t rownr, const DComplex *dataPtr)
void | put (rownr_t rownr, const String *dataPtr)
void | put (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | throwGet () const
| Throw an "invalid operation" exception for the default implementation of get.
void | throwPut () const
| Throw an "invalid operation" exception for the default implementation of put.
void | setColumnName (const String &colName)
| Set the column name.
const String & | columnName () const
| Get rhe column name.

## Protected Member Functions

| VACEngine (const VACEngine< T > &)
| Copy constructor is only used by clone().
Protected Member Functions inherited from casacore::DataManager
void | decrementNcolumn ()
| Decrement number of columns (in case a column is deleted).
void | setEndian (Bool bigEndian)
| Tell the data manager if big or little endian format is needed.
void | setTsmOption (const TSMOption &tsmOption)
| Tell the data manager which TSM option to use.
void | setMultiFile (const std::shared_ptr< MultiFileBase > &mfile)
| Tell the data manager that MultiFile can be used.
virtual Bool | hasMultiFileSupport () const
| Does the data manager support use of MultiFile?
void | throwDataTypeOther (const String &columnName, int dataType) const
| Throw an exception in case data type is TpOther, because the storage managers (and maybe other data managers) do not support such columns.
Protected Member Functions inherited from casacore::VirtualArrayColumn< T >
virtual void | getArray (rownr_t rownr, Array< T > &data)=0
| Get the array value in the given row.
virtual void | putArray (rownr_t rownr, const Array< T > &data)
| Put the array value into the given row.
virtual void | getSlice (rownr_t rownr, const Slicer &slicer, Array< T > &data)
| Get a section of the array in the given row.
virtual void | putSlice (rownr_t rownr, const Slicer &slicer, const Array< T > &data)
| Put into a section of the array in the given row.
virtual void | getArrayColumn (Array< T > &data)
| Get an entire column.
virtual void | putArrayColumn (const Array< T > &data)
| Put an entire column.
virtual void | getArrayColumnCells (const RefRows &rownrs, Array< T > &data)
| Get some array values in the column.
virtual void | putArrayColumnCells (const RefRows &rownrs, const Array< T > &data)
| Put some array values in the column.
virtual void | getColumnSlice (const Slicer &slicer, Array< T > &data)
| Get a section of all arrays in the column.
virtual void | putColumnSlice (const Slicer &slicer, const Array< T > &data)
| Put a section of all arrays in the column.
virtual void | getColumnSliceCells (const RefRows &rownrs, const Slicer &slicer, Array< T > &data)
| Get a section of some arrays in the column.
virtual void | putColumnSliceCells (const RefRows &rownrs, const Slicer &slicer, const Array< T > &data)
| Put into a section of some arrays in the column.
Protected Member Functions inherited from casacore::VirtualArrayColumnBase
virtual void | setShapeColumn (const IPosition &shape)
| Set the shape of all arrays in the column.
virtual void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of an array in the given row.
virtual Bool | isShapeDefined (rownr_t rownr)
| Is the value shape defined in the given row?
virtual IPosition | shape (rownr_t rownr)
| Get the shape of the item in the given row.
virtual void | getScalarColumnV (ArrayBase &dataPtr)
| The scalar access functions throw an exception.
virtual void | putScalarColumnV (const ArrayBase &dataPtr)
| Put all scalar values in the column.
virtual void | getScalarColumnCellsV (const RefRows &rownrs, ArrayBase &dataPtr)
| Get some scalar values in the column.
virtual void | putScalarColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr)
| Put some scalar values in the column.
Protected Member Functions inherited from casacore::DataManagerColumn
virtual void | getBool (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
virtual void | getuChar (rownr_t rownr, uChar *dataPtr)
virtual void | getShort (rownr_t rownr, Short *dataPtr)
virtual void | getuShort (rownr_t rownr, uShort *dataPtr)
virtual void | getInt (rownr_t rownr, Int *dataPtr)
virtual void | getuInt (rownr_t rownr, uInt *dataPtr)
virtual void | getInt64 (rownr_t rownr, Int64 *dataPtr)
virtual void | getfloat (rownr_t rownr, float *dataPtr)
virtual void | getdouble (rownr_t rownr, double *dataPtr)
virtual void | getComplex (rownr_t rownr, Complex *dataPtr)
virtual void | getDComplex (rownr_t rownr, DComplex *dataPtr)
virtual void | getString (rownr_t rownr, String *dataPtr)
virtual void | getOther (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
virtual void | putBool (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
virtual void | putuChar (rownr_t rownr, const uChar *dataPtr)
virtual void | putShort (rownr_t rownr, const Short *dataPtr)
virtual void | putuShort (rownr_t rownr, const uShort *dataPtr)
virtual void | putInt (rownr_t rownr, const Int *dataPtr)
virtual void | putuInt (rownr_t rownr, const uInt *dataPtr)
virtual void | putInt64 (rownr_t rownr, const Int64 *dataPtr)
virtual void | putfloat (rownr_t rownr, const float *dataPtr)
virtual void | putdouble (rownr_t rownr, const double *dataPtr)
virtual void | putComplex (rownr_t rownr, const Complex *dataPtr)
virtual void | putDComplex (rownr_t rownr, const DComplex *dataPtr)
virtual void | putString (rownr_t rownr, const String *dataPtr)
virtual void | putOther (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | getScalarColumnBase (ArrayBase &dataPtr)
| The default implementations of get and put functions.
void | putScalarColumnBase (const ArrayBase &dataPtr)
void | getScalarColumnCellsBase (const RefRows &rownrs, ArrayBase &dataPtr)
void | putScalarColumnCellsBase (const RefRows &rownrs, const ArrayBase &dataPtr)
void | getArrayColumnBase (ArrayBase &data)
void | putArrayColumnBase (const ArrayBase &data)
void | getArrayColumnCellsBase (const RefRows &rownrs, ArrayBase &data)
void | putArrayColumnCellsBase (const RefRows &rownrs, const ArrayBase &data)
void | getSliceBase (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
void | putSliceBase (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceBase (const Slicer &slicer, ArrayBase &data)
void | putColumnSliceBase (const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
void | putColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)

## Private Member Functions

Bool | isWritable () const
| The column is in principle writable.
DataManagerColumn * | makeDirArrColumn (const String &columnName, int dataType, const String &dataTypeID)
| Create the column object for the array column in this engine.
DataManagerColumn * | makeIndArrColumn (const String &columnName, int dataType, const String &dataTypeID)
| Create an indirect array column.

## Private Attributes

String | sourceName_p

## Additional Inherited Members

Static Public Member Functions inherited from casacore::DataManager
static void | registerCtor (const String &type, DataManagerCtor func)
| Register a mapping of a data manager type to its static construction function.
static DataManagerCtor | getCtor (const String &dataManagerType)
| Get the "constructor" of a data manager (thread-safe).
static Bool | isRegistered (const String &dataManagerType)
| Test if a data manager is registered (thread-safe).
static DataManager * | unknownDataManager (const String &dataManagerType, const Record &spec)
| Serve as default function for theirRegisterMap, which catches all unknown data manager types.
Static Public Attributes inherited from casacore::DataManager
static rownr_t | MAXROWNR32
| Define the highest row number that can be represented as signed 32-bit.

## Detailed Description

template<class T>
class casacore::VACEngine< T >

Base virtual column for an array column with any type

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Intended use:

Public interface

### Prerequisite

- VirtualColumnEngine
- VirtualArrayColumn

### Etymology

VACEngine stands for Virtual Array Column Engine, i.e. a class handling a virtual table column containing array values.

### Synopsis

VACEngine is a base virtual column engine to handle a column with an arbitrary type. Data of columns with standard data types can directly be stored in a Table using a storage manager, but data of column with non-standard types have to be stored in another way. The way to do this is to split the object with the non-standard type into its individual elements, which are subsequently put into the appropriate columns.

A virtual column engine has to be implemented for each non-standard data type, which has to be stored in a table. This engine has to get and put the individual parts the object. VACEngine is the base class for such engines, so the actual engine quite simple to implement. The example shows the implementation of an engine AVACEngine handling a data type A.

In principle the name of the engine class is free, but it is strongly recommended to use the name <dataTypeId>VACEngine, where VAC stands for Virtual Array Column (e.g. AVACEngine for class A). In this way the default data manager name supplied by the class and by class ArrayColumnDesc can be used.

### Example

This example shows the implementation of an engine class AVACEngine, which stores the data of a class A. The data objects A are stored in a column called the source column. The user has to associate two target columns with it. The engine stores the data parts x and y in the target columns. The names of the target columns are stored as keywords in the source column. In this way the engine can reconstruct itself when the table is read back.

In the example all AVACEngine functions are shown inline, but they should be implemented out-of-line in a separate.cc file.

//# AVACEngine.h: Example virtual column engine to handle data type A
#if !defined(AIPS_AVACENGINE_H)
\#define AIPS_AVACENGINE_H
//# Includes
#include <casacore/tables/DataMan/VACEngine.h>
#include <casacore/tables/Tables/ArrayColumn.h>
// Define the class A.
class A
{
public:
A(): x_p(0), y_p(0) {}
A(Int x, float y) : x_p(x), y_p(y) {}
A(const A& that): x_p(that.x_p), y_p(that.y_p) {}
static String dataTypeId()
{ return "A"; }
Int x() const
{ return x_p; }
float y() const
{ return y_p; }
Int& x()
{ return x_p; }
float& y()
{ return y_p; }
int operator== (const A& that) const
{ return x_p==that.x_p && y_p==that.y_p; }
int operator< (const A& that) const
{ return x_p<that.x_p || (x_p==that.x_p && y_p<that.y_p); }
private:
Int x_p;
float y_p;
};
// Now define the engine to handle objects of type A.
class AVACEngine : public VACEngine<A>
{
public:
// The default constructor is required for reconstruction of the
// engine when a table is read back.
AVACEngine() = default;
// Construct the engine for the given source column and storing
// the result in the given target columns for the data members
// x and y of class A.
AVACEngine (const String& sourceColumnName,
const String& xTargetColumnName,
const String& yTargetColumnname)
: VACEngine<A> (sourceColumnName),
xTargetName_p (xTargetColumnName),
yTargetName_p (yTargetColumnName)
{}
// Destructor is only needed if something has to be destructed.
~AVACEngine() = override
{}
// Assignment is not needed and therefore forbidden.
AVACEngine& operator= (const AVACEngine&) = delete;
// Clone the object.
virtual DataManager* clone() const
{
DataManager* dmPtr = new AVACEngine (sourceColumnName(),
xTargetName_p, yTargetName_p);
return dmPtr;
}
// Store the target column names in the source column keywords.
virtual void create (rownr_t)
{
TableColumn src (table(), sourceColumnName());
src.keywordSet().keysString()("_xTargetName") = xTargetName_p;
src.keywordSet().keysString()("_yTargetName") = yTargetName_p;
}
// Prepare the engine by allocating column objects
// for the target columns.
virtual void prepare()
{
TableColumn src (table(), sourceColumnName());
xTargetName_p = src.keywordSet().asString ("_xTargetName");
yTargetName_p = src.keywordSet().asString ("_yTargetName");
rocolx.attach (table(), xTargetName_p);
rocoly.attach (table(), yTargetName_p);
if (table().isWritable()) {
colx.attach (table(), xTargetName_p);
coly.attach (table(), yTargetName_p);
}
}
// Get the data from a row.
virtual void get (rownr_t rownr, A& value)
{
rocolx.get (rownr, value.x());
rocoly.get (rownr, value.y());
}
// Put the data in a row.
virtual void put (rownr_t rownr, const A& value)
{
colx.put (rownr, value.x());
coly.put (rownr, value.y());
}
// Register the class name and the static makeObject "constructor".
// This will make the engine known to the table system.
static void registerClass()
{
DataManager::registerCtor ("AVACEngine", makeObject);
}
private:
// Copy constructor is only used by clone().
// (so it is made private).
AVACEngine (const AVACEngine&)
: VACEngine<A> (that),
xTargetName_p (that.xTargetName_p),
yTargetName_p (that.yTargetName_p)
{}
// The target column names.
String xTargetName_p;
String yTargetName_p;
// Objects for the target columns.
ArrayColumn<Int> colx; // used by put
ArrayColumn<Int> rocolx; // used by get
ArrayColumn<float> coly; // used by put
ArrayColumn<float> rocoly; // used by get
public:
// Define the "constructor" to construct this engine when a
// table is read back.
// This "constructor" has to be registered by the user of the engine.
// Function registerClass() is doing that.
static DataManager* makeObject (const String& dataManagerType)
{
DataManager* dmPtr = new AVACEngine();
return dmPtr;
}
};
#endif
casacore::VACEngine::VACEngine
VACEngine()=default
The default constructor is required for reconstruction of the engine when a table is read back.
casacore::define
void define(const T &value)
Store a value in the field using redefinition.
casacore::Int
int Int
Definition aipstype.h:48
casacore::value
LatticeExprNode value(const LatticeExprNode &expr)
This function returns the value of the expression without a mask.
casacore::put
void put(const T v)
Accumulate (put) value(s) into the histogram.
casacore::get
const T & get() const
Definition RecordField.h:143
casacore::clone
RecordInterface * clone() const override
Make a copy of this object.
Definition Polynomial.h:122

User code using this engine to create a new table could look like:

// Register the engine.
// This is not needed if the engine is registered as part
// of the general DataManager::registerAllCtor function.
AVACEngine::registerClass();
// Create the table description.
TableDesc td;
td.addColumn (ArrayColumnDesc<A>("source"));
td.addColumn (ArrayColumnDesc<Int>("xTarget"));
td.addColumn (ArrayColumnDesc<Int>("yTarget"));
SetupNewTable setup ("table.name", td, Table::New);
// Define the engine for column "source".
AVACEngine engine ("source", "xTarget", "yTarget");
Table tab (setup, 10);
// Put data into column "source".
ArrayColumn<A> col (tab, "source");
for (uInt i=0; i<10; i++) {
col.put (i, someA); // writes indirectly xTarget and yTarget
}
casacore::ArrayColumnDesc
Templated class for description of table array columns.
Definition ArrColDesc.h:235
casacore::ArrayColumn
Definition ArrayColumn.h:98
casacore::SetupNewTable
Create a new table - define shapes, data managers, etc.
Definition SetupNewTab.h:337
casacore::TableDesc
Definition TableDesc.h:189
casacore::TableDesc::addColumn
ColumnDesc & addColumn(const ColumnDesc &)
Add a column to the table description.
Definition TableDesc.h:568
casacore::Table
Definition Table.h:157
casacore::Table::New
@ New
create table
Definition Table.h:175
casacore::uInt
unsigned int uInt
Definition aipstype.h:49

### Motivation

This class makes it easier for the user to implement the engine. It supplies several default functions.

### Template Type Argument Requirements (T)

- Default constructor T();
- Copy constructor T(const T&);
- Assignment operator T& operator= (const T&);
- comparison operator int operator== (const T&) const;
- comparison operator int operator< (const T&) const;
- identification static String dataTypeId(); This should return the (unique) name of the class, thus when T is templated in its turn, the name should contain the template argument name.

Definition at line 284 of file VACEngine.h.

## Constructor & Destructor Documentation

## VACEngine() [1/3]

template<class T>

casacore::VACEngine< T >::VACEngine | ( |  | ) |

default

The default constructor is required for reconstruction of the engine when a table is read back.

It is also used to construct an engine, which does not check the source column name.

Referenced by operator=(), and VACEngine().

## VACEngine() [2/3]

template<class T>

casacore::VACEngine< T >::VACEngine | ( | const String & | sourceColumnName | ) |

Construct an engine to handle a column with an arbitrary data type.

Later it will check if the source column name is correct.

References sourceColumnName().

## ~VACEngine()

template<class T>

virtual casacore::VACEngine< T >::~VACEngine | ( |  | ) |

virtual default

Destructor.

## VACEngine() [3/3]

template<class T>

casacore::VACEngine< T >::VACEngine | ( | const VACEngine< T > & |  | ) |

protected

Copy constructor is only used by clone().

(so it is made protected).

References VACEngine().

## Member Function Documentation

## dataManagerType()

template<class T>

String casacore::VACEngine< T >::dataManagerType | ( |  | ) | const

virtual

Return the data manager type name.

This defaults to the data type ID followed by VACEngine (meaning Virtual Array Column Engine).

Implements casacore::DataManager.

## isWritable()

template<class T>

Bool casacore::VACEngine< T >::isWritable | ( |  | ) | const

private virtual

The column is in principle writable.

This does not mean it is actually writable, because that depends on the fact if the table is writable.

Reimplemented from casacore::VirtualArrayColumnBase.

## makeDirArrColumn()

template<class T>

DataManagerColumn * casacore::VACEngine< T >::makeDirArrColumn | ( | const String & | columnName,
|  | int | dataType,
|  | const String & | dataTypeID )

private virtual

Create the column object for the array column in this engine.

It will check if the given column name matches the source column name. This assures that the engine is bound to the correct column.

Reimplemented from casacore::VirtualColumnEngine.

References casacore::DataManagerColumn::columnName(), and casacore::VirtualArrayColumn< T >::dataType().

## makeIndArrColumn()

template<class T>

DataManagerColumn * casacore::VACEngine< T >::makeIndArrColumn | ( | const String & | columnName,
|  | int | dataType,
|  | const String & | dataTypeId )

private virtual

Create an indirect array column.

The default implementation throws an exception that it cannot do it for this column.

Reimplemented from casacore::VirtualColumnEngine.

References casacore::DataManagerColumn::columnName(), and casacore::VirtualArrayColumn< T >::dataType().

## operator=()

template<class T>

VACEngine< T > & casacore::VACEngine< T >::operator= | ( | const VACEngine< T > & |  | ) |

delete

Assignment is not needed and therefore forbidden.

References VACEngine().

## sourceColumnName()

template<class T>

const String & casacore::VACEngine< T >::sourceColumnName | ( |  | ) | const

inline

Get the name of the source column.

Definition at line 314 of file VACEngine.h.

References sourceName_p.

Referenced by VACEngine().

## Member Data Documentation

## sourceName_p

template<class T>

String casacore::VACEngine< T >::sourceName_p

private

Definition at line 341 of file VACEngine.h.

Referenced by sourceColumnName().

The documentation for this class was generated from the following file:

- tables/DataMan/VACEngine.h